# CapNHook-ML

Optimised math library for CapnHook repository.

## Features
- [x] numpy ndarray support
- [x] numpy like API with:
    - [x] elementwise operations
    - [x] broadcasting
    - [x] reduction operations
    - [x] linear algebra operations
- [-] common ML operations:
    - [x] matrix multiplication
    - [ ] convolution
    - [ ] pooling
    - [ ] activation functions
    - [ ] loss functions
    - [ ] optimizers
- [ ] common statistics operations:
    - [ ] mean
    - [ ] median
    - [ ] mode
    - [ ] variance
    - [ ] standard deviation
    - [ ] covariance
    - [ ] correlation

## Motivation

We motivate the use of libraries/technologies through very basic benchmarks. The goal is to show the reasoning behind the design decisions of this project. Currently, we motivate:
- [Why this library exists](motivation/numpy_slow_motivation/)

## Installation
To install this library, run:
```bash
pip install capnhook_ml
```